// ************************ js popup generator
// formgen V. 0.1.1 26 April 2020
// free to use but no warranties
// El Condor - Condor Informatique - Turin
// ************************
if (typeof(window.$) != "function") var $ = function (id) {return document.getElementById(id);};  // wrap getElementById
function popUp(content) {
	var dimension = function(p) {return (p > 0) ? p+"px":"auto";}
	var clickOnce = function(event) {
		closePopUp(fade[1]);
		link.removeEventListener('click', clickOnce);
	};
	var hitOnce = function(event) {
		if(event.key == parms.cancel) {
			closePopUp(fade[1]);
			window.removeEventListener("keydown",hitOnce);
		}
	};
	var closePopUp = async function (t) {			// close popup
		if (t > 0) fader(link,t, false)
		setTimeout(() => {link.remove();
		},t)
	}
	var fader =	function (elem, speed, fadeIn) {	// fading function
		var opx = (fadeIn)? 1 : elem.style.opacity;
		var outInterval = setInterval(function() { 
			elem.style.opacity = (fadeIn)? 1-opx : opx;
			if (opx <= 0) clearInterval(outInterval);
			else opx -= 0.02;
		}, speed / 50);
	}
	var parms = {"width":-1,"height":-1,"top":-1,"left":-1,"id":"","cancel":"click","content":"","style":"","class":"","fade":""}
	for (key in content) parms[key.toLowerCase()] = content[key]
	fade = (parms.fade+" 0 0").split(/\s+/);
	var status = (parms.id == "")? -1: ($(parms.id) != null)? 1: 0;	//	-1 no ID, 0 Id not present, 1 id exists
	var style = "opacity:0;";
	var link = document.createElement("div");
	if (parms.id != "") link.setAttribute('id', parms.id);
	if (parms.class != "") link.setAttribute('class', parms.class);
	if (status < 1) style += "position:absolute;display:inline-block;"
	style += "width:"+dimension(parms.width)
		  +";height:"+dimension(parms.height)
		  +";"
	if (parms.top != -1) style += "top:"+parms.top+"px;"
	if (parms.left != -1) style += "left:"+parms.left+"px;"
	if (status < 1) link = document.body.insertAdjacentElement('afterbegin',link);
	else link = $(parms.id).appendChild(link);
	link.setAttribute("style",style+parms.style);
	link.innerHTML = parms.content;
	var images = link.getElementsByTagName("img");
	if (images.length == 1) {
		var image = images[0];
		image.onload = function() {
			if (parms.width > 0) {
				image.style.width = parms.width
				if (parms.height < 0) image.style.height = image.naturalHeight * parms.width / image.naturalWidth
			}
			if (parms.height > 0) {
				image.style.height = parms.height
				if (parms.width < 0) image.style.width = image.naturalwidth * parms.height / image.naturalHeight
			}
			if (parms.top == -1) link.style.top = 0.5 * (window.innerHeight - link.offsetHeight);
			if (parms.left == -1) link.style.left = 0.5 * (window.innerWidth - link.offsetWidth);
		}
	} else {
		if (parms.top == -1) link.style.top = 0.5 * (window.innerHeight - link.offsetHeight);
		if (parms.left == -1) link.style.left = 0.5 * (window.innerWidth - link.offsetWidth);
	}
	if (typeof parms.cancel == "number") setTimeout(closePopUp,parms.cancel-fade[1],fade[1]);
	else if (typeof parms.cancel.toLowerCase() != "no"){
		if (parms.cancel.toLowerCase() == "click") {
			link.addEventListener("click",clickOnce);
		} else
			window.addEventListener("keydown", hitOnce);
	}
	if (fade[0] == 0) setTimeout(() => {link.style.opacity = 1;},100);
	else fader(link,fade[0], true);
}